"use client";
import axios, { axiosPrivate } from '../api/axios';
import { useRouter } from 'next/navigation';
import React, { ReactNode, useEffect } from 'react'
import { useAuth } from '../contexts/AuthContext';
import Loader from '../components/Loader';
interface PageProps {
  children: ReactNode;
 }
const RequireLogin = ({ children }: PageProps ) => {
  const { token, isTokenLoaded, setUserInfo } = useAuth();
  const router = useRouter()

  const verifyToken = async () => {
    try{
      const response = await axiosPrivate(token!).get('/auth/verify')
      if( response.status !== 200 ){
        router.push('/');
      }
      setUserInfo(response.data);
    }catch(err){
      console.log(err);
    }
  }
  useEffect(() => {
    if(isTokenLoaded){
      console.log(token)
      if(!token){
        router.push('/');
      }else{
        verifyToken();
      }
    }

  }, [token, isTokenLoaded]);
  if(isTokenLoaded && token){
    return (
      <>
      {children}
      </>
    )
  }else{
    return <Loader />
  }

}

export default RequireLogin